diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.h ns-3.47/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.h
--- ns-3.46/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.h	2026-02-16 16:08:49.825230800 -0800
@@ -16,7 +16,6 @@
 #include "ns3/random-variable-stream.h"
 
 #include <complex.h>
-#include <map>
 #include <unordered_map>
 
 class ThreeGppCalcLongTermMultiPortTest;
@@ -125,7 +124,7 @@
     /**
      * Data structure that stores the long term component for a tx-rx pair
      */
-    struct LongTerm : public SimpleRefCount<LongTerm>
+    struct LongTerm : SimpleRefCount<LongTerm>
     {
         Ptr<const MatrixBasedChannelModel::Complex3DVector>
             m_longTerm; //!< vector containing the long term component for each cluster
@@ -149,15 +148,15 @@
      * @param isReverse true if params and longTerm were computed with RX->TX switched
      * @return 3D spectrum channel matrix with dimensions numRxPorts * numTxPorts * numRBs
      */
-    Ptr<MatrixBasedChannelModel::Complex3DVector> GenSpectrumChannelMatrix(
+    static Ptr<MatrixBasedChannelModel::Complex3DVector> GenSpectrumChannelMatrix(
         Ptr<SpectrumValue> inPsd,
         Ptr<const MatrixBasedChannelModel::Complex3DVector> longTerm,
         Ptr<const MatrixBasedChannelModel::ChannelMatrix> channelMatrix,
         Ptr<const MatrixBasedChannelModel::ChannelParams> channelParams,
         PhasedArrayModel::ComplexVector doppler,
-        uint8_t numTxPorts,
-        uint8_t numRxPorts,
-        bool isReverse) const;
+        const uint8_t numTxPorts,
+        const uint8_t numRxPorts,
+        const bool isReverse);
 
     /**
      * Get the operating frequency
@@ -193,6 +192,13 @@
     /**
      * @brief Computes a longTerm component from a specific port of s device to the
      * specific port of u device and for a specific cluster index
+     *
+     * The beamformed (long-term) effective channel coefficient:
+     * \f$ h_{\rm eff} = \mathbf{w}_{\rm rx}^H \mathbf{H} \mathbf{w}_{\rm tx} \f$.
+     *
+     * @note The RX beamforming vector is stored on the antenna as \f$\mathbf{w}_{\rm rx}\f$.
+     *       This function applies it as a Hermitian inner product (i.e., uses the complex
+     *       conjugate of the RX weights) when forming \f$\mathbf{w}_{\rm rx}^H\f$.
      * @param params The params that include the channel matrix
      * @param sAnt pointer to first antenna
      * @param uAnt uAnt pointer to second antenna
@@ -205,9 +211,9 @@
         Ptr<const MatrixBasedChannelModel::ChannelMatrix> params,
         Ptr<const PhasedArrayModel> sAnt,
         Ptr<const PhasedArrayModel> uAnt,
-        uint16_t sPortIdx,
-        uint16_t uPortIdx,
-        uint16_t cIndex) const;
+        const uint16_t sPortIdx,
+        const uint16_t uPortIdx,
+        const uint16_t cIndex) const;
 
     /**
      * @brief Computes the beamforming gain and applies it to the TX PSD
@@ -218,7 +224,7 @@
      * @param sSpeed the speed of the first node
      * @param uSpeed the speed of the second node
      * @param numTxPorts the number of the ports of the first node
-     * @param numRxPorts the number of the porst of the second node
+     * @param numRxPorts the number of the ports of the second node
      * @param isReverse indicator that tells whether the channel matrix is reverse
      * @return
      */
@@ -229,15 +235,16 @@
         Ptr<const MatrixBasedChannelModel::ChannelParams> channelParams,
         const Vector& sSpeed,
         const Vector& uSpeed,
-        uint8_t numTxPorts,
-        uint8_t numRxPorts,
-        bool isReverse) const;
+        const uint8_t numTxPorts,
+        const uint8_t numRxPorts,
+        const bool isReverse) const;
 
     int64_t DoAssignStreams(int64_t stream) override;
 
-    mutable std::unordered_map<uint64_t, Ptr<const LongTerm>>
-        m_longTermMap;                           //!< map containing the long term components
-    Ptr<MatrixBasedChannelModel> m_channelModel; //!< the model to generate the channel matrix
+    //! map containing the long-term components
+    mutable std::unordered_map<uint64_t, Ptr<const LongTerm>> m_longTermMap;
+    //! the model to generate the channel matrix
+    Ptr<MatrixBasedChannelModel> m_channelModel;
 };
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/spectrum/test/three-gpp-channel-test-suite.cc ns-3.47/src/spectrum/test/three-gpp-channel-test-suite.cc
--- ns-3.46/src/spectrum/test/three-gpp-channel-test-suite.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/spectrum/test/three-gpp-channel-test-suite.cc	2026-02-16 16:08:49.826230800 -0800
@@ -1,14 +1,16 @@
 /*
  * Copyright (c) 2019 SIGNET Lab, Department of Information Engineering,
- *
+ * Copyright (c) 2026, Centre Tecnologic de Telecomunicacions de Catalunya (CTTC)
  * SPDX-License-Identifier: GPL-2.0-only
  */
 
 #include "ns3/abort.h"
 #include "ns3/angles.h"
+#include "ns3/boolean.h"
 #include "ns3/channel-condition-model.h"
 #include "ns3/config.h"
 #include "ns3/constant-position-mobility-model.h"
+#include "ns3/constant-velocity-mobility-model.h"
 #include "ns3/double.h"
 #include "ns3/ism-spectrum-value-helper.h"
 #include "ns3/isotropic-antenna-model.h"
@@ -16,7 +18,6 @@
 #include "ns3/node-container.h"
 #include "ns3/pointer.h"
 #include "ns3/rng-seed-manager.h"
-#include "ns3/simple-net-device.h"
 #include "ns3/simulator.h"
 #include "ns3/spectrum-signal-parameters.h"
 #include "ns3/string.h"
@@ -148,41 +149,32 @@
 
     // create the channel condition model
     Ptr<ChannelConditionModel> channelConditionModel =
-        CreateObject<NeverLosChannelConditionModel>();
+        CreateObject<AlwaysLosChannelConditionModel>();
 
     // create the ThreeGppChannelModel object used to generate the channel matrix
     Ptr<ThreeGppChannelModel> channelModel = CreateObject<ThreeGppChannelModel>();
     channelModel->SetAttribute("Frequency", DoubleValue(60.0e9));
     channelModel->SetAttribute("Scenario", StringValue("RMa"));
     channelModel->SetAttribute("ChannelConditionModel", PointerValue(channelConditionModel));
-    channelModel->SetAttribute("UpdatePeriod", TimeValue(MilliSeconds(updatePeriodMs - 1)));
+    channelModel->SetAttribute("UpdatePeriod", TimeValue(MilliSeconds(updatePeriodMs)));
     channelModel->AssignStreams(1);
 
     // create the tx and rx nodes
     NodeContainer nodes;
     nodes.Create(2);
 
-    // create the tx and rx devices
-    Ptr<SimpleNetDevice> txDev = CreateObject<SimpleNetDevice>();
-    Ptr<SimpleNetDevice> rxDev = CreateObject<SimpleNetDevice>();
-
-    // associate the nodes and the devices
-    nodes.Get(0)->AddDevice(txDev);
-    txDev->SetNode(nodes.Get(0));
-    nodes.Get(1)->AddDevice(rxDev);
-    rxDev->SetNode(nodes.Get(1));
-
     // create the tx and rx mobility models and set their positions
     Ptr<MobilityModel> txMob = CreateObject<ConstantPositionMobilityModel>();
     txMob->SetPosition(Vector(0.0, 0.0, 10.0));
-    Ptr<MobilityModel> rxMob = CreateObject<ConstantPositionMobilityModel>();
-    rxMob->SetPosition(Vector(100.0, 0.0, 10.0));
+    Ptr<ConstantVelocityMobilityModel> rxMob = CreateObject<ConstantVelocityMobilityModel>();
+    rxMob->SetPosition(Vector(30.0, 0.0, 10.0));
+    rxMob->SetVelocity(Vector(50, 0, 0));
 
     // associate the nodes and the mobility models
     nodes.Get(0)->AggregateObject(txMob);
     nodes.Get(1)->AggregateObject(rxMob);
 
-    // create the tx and rx antennas and set the their dimensions
+    // create the tx and rx antennas and set their dimensions
     Ptr<PhasedArrayModel> txAntenna = CreateObjectWithAttributes<UniformPlanarArray>(
         "NumColumns",
         UintegerValue(m_txAntennaElements),
@@ -221,10 +213,10 @@
         "The second dimension of H should be equal to the number of rx antenna elements");
 
     // test if the channel matrix is correctly generated
-    uint16_t numIt = 1000;
+    uint16_t numIt = 2000;
     for (uint16_t i = 0; i < numIt; i++)
     {
-        Simulator::Schedule(MilliSeconds(updatePeriodMs * i),
+        Simulator::Schedule(MilliSeconds(updatePeriodMs * i + i),
                             &ThreeGppChannelMatrixComputationTest::DoComputeNorm,
                             this,
                             channelModel,
@@ -248,25 +240,34 @@
     double sampleStd = 0;
     for (auto i : m_normVector)
     {
-        sampleStd += ((i - sampleMean) * (i - sampleMean));
+        const double diff = i - sampleMean;
+        sampleStd += diff * diff;
     }
     sampleStd = std::sqrt(sampleStd / (numIt - 1));
 
-    // perform the one sample t-test with a significance level of 0.05 to test
-    // the hypothesis "E [|H|^2] = M*N, where |H| indicates the Frobenius norm of
-    // H, M is the number of transmit antenna elements, and N is the number of
-    // the receive antenna elements"
-    double t = (sampleMean - m_txAntennaElements * m_txAntennaElements * m_rxAntennaElements *
-                                 m_rxAntennaElements) /
-               (sampleStd / std::sqrt(numIt));
-
-    // Using a significance level of 0.05, we reject the null hypothesis if |t| is
-    // greater than the critical value from a t-distribution with df = numIt-1
-    NS_TEST_ASSERT_MSG_EQ_TOL(
-        std::abs(t),
-        0,
-        1.65,
-        "We reject the hypothesis E[|H|^2] = M*N with a significance level of 0.05");
+    NS_TEST_ASSERT_MSG_NE(sampleStd,
+                          0,
+                          "The STD should be different from zero. Channel matrix not updated");
+
+    if (sampleStd != 0)
+    {
+        // perform the one sample t-test with a significance level of 0.05 to test
+        // the hypothesis "E [|H|^2] = M*N, where |H| indicates the Frobenius norm of
+        // H, M is the number of transmit antenna elements, and N is the number of
+        // the receive antenna elements"
+        double t = (sampleMean - m_txAntennaElements * m_txAntennaElements * m_rxAntennaElements *
+                                     m_rxAntennaElements) /
+                   (sampleStd / std::sqrt(numIt));
+
+        // Using a significance level of 0.05, we reject the null hypothesis if |t| is
+        // greater than the critical value from a t-distribution with df = numIt-1
+
+        NS_TEST_ASSERT_MSG_EQ_TOL(
+            std::abs(t),
+            0,
+            1.65,
+            "We reject the hypothesis E[|H|^2] = M*N with a significance level of 0.05");
+    }
 
     Simulator::Destroy();
 }
@@ -308,8 +309,10 @@
     void DoRun() override;
 
     /**
-     * This method is used to schedule the channel matrix computation at different
-     * time instants and to check if it correctly updated
+     * This method first slightly moves the user and then calculates the channel matrix.
+     * This function is used for channel matrix computation at different time instants
+     * and to check if whether the channel matrix is updated following the updatePeriod
+     * configuration.
      * @param channelModel the ThreeGppChannelModel object used to generate the channel matrix
      * @param txMob the mobility model of the first node
      * @param rxMob the mobility model of the second node
@@ -317,17 +320,19 @@
      * @param rxAntenna the antenna object associated to the second node
      * @param update whether if the channel matrix should be updated or not
      */
-    void DoGetChannel(Ptr<ThreeGppChannelModel> channelModel,
-                      Ptr<MobilityModel> txMob,
-                      Ptr<MobilityModel> rxMob,
-                      Ptr<PhasedArrayModel> txAntenna,
-                      Ptr<PhasedArrayModel> rxAntenna,
-                      bool update);
+    void MoveRxAndComputerSnr(Ptr<ThreeGppChannelModel> channelModel,
+                              Ptr<MobilityModel> txMob,
+                              Ptr<MobilityModel> rxMob,
+                              Ptr<PhasedArrayModel> txAntenna,
+                              Ptr<PhasedArrayModel> rxAntenna,
+                              bool update);
 
     Ptr<const ThreeGppChannelModel::ChannelMatrix>
-        m_currentChannel;            //!< used by DoGetChannel to store the current channel matrix
-    uint32_t m_txAntennaElements{4}; //!< number of rows and columns of tx antenna array
-    uint32_t m_rxAntennaElements{4}; //!< number of rows and columns of rx antenna array
+        m_currentChannel;      //!< used by DoGetChannel to store the current channel matrix
+    bool m_initialized{false}; //!< tracks whether previous matrix snapshot is set
+    ComplexMatrixArray m_previousChannelMatrix; //!< snapshot of previous channel matrix
+    uint32_t m_txAntennaElements{4};            //!< number of rows and columns of tx antenna array
+    uint32_t m_rxAntennaElements{4};            //!< number of rows and columns of rx antenna array
     uint32_t m_txPorts{1}; //!< number of horizontal and vertical ports of tx antenna array
     uint32_t m_rxPorts{1}; //!< number of horizontal and vertical ports of rx antenna array
 };
@@ -349,36 +354,60 @@
 }
 
 void
-ThreeGppChannelMatrixUpdateTest::DoGetChannel(Ptr<ThreeGppChannelModel> channelModel,
-                                              Ptr<MobilityModel> txMob,
-                                              Ptr<MobilityModel> rxMob,
-                                              Ptr<PhasedArrayModel> txAntenna,
-                                              Ptr<PhasedArrayModel> rxAntenna,
-                                              bool update)
-{
+ThreeGppChannelMatrixUpdateTest::MoveRxAndComputerSnr(Ptr<ThreeGppChannelModel> channelModel,
+                                                      Ptr<MobilityModel> txMob,
+                                                      Ptr<MobilityModel> rxMob,
+                                                      Ptr<PhasedArrayModel> txAntenna,
+                                                      Ptr<PhasedArrayModel> rxAntenna,
+                                                      bool update)
+{
+    // 3GPP channel update is activated only if the UE displacement is at least 1e-6, hence we
+    // add this minor movement to allow triggering of the channel update per the configured channel
+    // update period
+    rxMob->SetPosition(Vector(rxMob->GetPosition().x + 0.01,
+                              rxMob->GetPosition().y + 0.01,
+                              rxMob->GetPosition().z));
+
     // retrieve the channel matrix
-    Ptr<const ThreeGppChannelModel::ChannelMatrix> channelMatrix =
+    Ptr<const ThreeGppChannelModel::ChannelMatrix> newChannelMatrix =
         channelModel->GetChannel(txMob, rxMob, txAntenna, rxAntenna);
 
-    if (!m_currentChannel)
+    // For in-place updates, the ChannelMatrix pointer may remain the same.
+    // Deep-compare the matrix values with a small tolerance.
+    if (!m_initialized)
     {
-        // this is the first time we compute the channel matrix, we initialize
-        // m_currentChannel
-        m_currentChannel = channelMatrix;
+        m_previousChannelMatrix = newChannelMatrix->m_channel; // deep copy
+        m_currentChannel = newChannelMatrix;
+        m_initialized = true;
+        return;
     }
-    else
+
+    // Use absolute tolerance on complex values (magnitude comparison)
+    std::complex<double> tol(1e-12, 0.0);
+    bool equal = m_previousChannelMatrix.IsAlmostEqual(newChannelMatrix->m_channel, tol);
+    bool changed = !equal;
+
+    NS_TEST_ASSERT_MSG_EQ(
+        changed,
+        update,
+        Simulator::Now().GetMilliSeconds()
+            << " The channel matrix is not updated respecting the updatePeriod configuration");
+
+    // Update the previous snapshot if an update was expected and occurred
+    if (changed)
     {
-        // compare the old and the new channel matrices
-        NS_TEST_ASSERT_MSG_EQ((m_currentChannel->m_channel != channelMatrix->m_channel),
-                              update,
-                              Simulator::Now().GetMilliSeconds()
-                                  << " The channel matrix is not correctly updated");
+        m_previousChannelMatrix = newChannelMatrix->m_channel;
+        m_currentChannel = newChannelMatrix;
     }
 }
 
 void
 ThreeGppChannelMatrixUpdateTest::DoRun()
 {
+    m_initialized = false;
+    m_previousChannelMatrix = ComplexMatrixArray();
+    m_currentChannel = nullptr;
+
     // Build the scenario for the test
     uint32_t updatePeriodMs = 100; // update period in ms
 
@@ -397,16 +426,6 @@
     NodeContainer nodes;
     nodes.Create(2);
 
-    // create the tx and rx devices
-    Ptr<SimpleNetDevice> txDev = CreateObject<SimpleNetDevice>();
-    Ptr<SimpleNetDevice> rxDev = CreateObject<SimpleNetDevice>();
-
-    // associate the nodes and the devices
-    nodes.Get(0)->AddDevice(txDev);
-    txDev->SetNode(nodes.Get(0));
-    nodes.Get(1)->AddDevice(rxDev);
-    rxDev->SetNode(nodes.Get(1));
-
     // create the tx and rx mobility models and set their positions
     Ptr<MobilityModel> txMob = CreateObject<ConstantPositionMobilityModel>();
     txMob->SetPosition(Vector(0.0, 0.0, 10.0));
@@ -448,7 +467,7 @@
     uint32_t firstTimeMs =
         1; // time instant at which the channel matrix is generated for the first time
     Simulator::Schedule(MilliSeconds(firstTimeMs),
-                        &ThreeGppChannelMatrixUpdateTest::DoGetChannel,
+                        &ThreeGppChannelMatrixUpdateTest::MoveRxAndComputerSnr,
                         this,
                         channelModel,
                         txMob,
@@ -460,7 +479,7 @@
     // call GetChannel before the update period is exceeded, the channel matrix
     // should not be updated
     Simulator::Schedule(MilliSeconds(firstTimeMs + updatePeriodMs / 2),
-                        &ThreeGppChannelMatrixUpdateTest::DoGetChannel,
+                        &ThreeGppChannelMatrixUpdateTest::MoveRxAndComputerSnr,
                         this,
                         channelModel,
                         txMob,
@@ -472,7 +491,7 @@
     // call GetChannel when the update period is exceeded, the channel matrix
     // should be recomputed
     Simulator::Schedule(MilliSeconds(firstTimeMs + updatePeriodMs + 1),
-                        &ThreeGppChannelMatrixUpdateTest::DoGetChannel,
+                        &ThreeGppChannelMatrixUpdateTest::MoveRxAndComputerSnr,
                         this,
                         channelModel,
                         txMob,
